<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <title>Example SSVG engine Vue.js integration</title>
  <script src="https://cdn.jsdelivr.net/npm/vue@3.3.4/dist/vue.global.min.js"></script>
  <script src="https://ssvg.web.cern.ch/distfiles/js/ssvg-engine-1.1.js"></script>
  <script>
    function init() {
      const app = Vue.createApp({
        ssvg: null,
        data() { return { range: 0 }; },
        watch: {
          range() { this.$options.ssvg.updateState(this.$data); }
        },
        mounted() {
          this.$options.ssvg = new window.ssvg.SSVGEngine(this.$refs.svg);
        },
        beforeDestroy() {
          this.$options.ssvg.disconnect();
        }
      });
      app.mount('#template');
    }
  </script>
</head>

<body onload="init()">
  <div>
    <h3><span>Vue.js integration example</span></h3>
    <div class="card">
      <div class="card-body">
        <div id="template">
          <input v-model="range" type="range" value="0" class="custom-input w-100" />
          <svg ref="svg" width="100%" xmlns="http://www.w3.org/2000/svg" height="40%">
            <state><!---->
              <property name="range" min="0" max="100" type="number" initial="0">
                <relation query-selector="#rect2" attribute-name="width" from="100%" to="0%"></relation>
                <relation query-selector="#rect1" attribute-name="width" from="0%" to="100%"></relation>
                <relation query-selector="#rect1" attribute-name="fill" to="blue"></relation>
              </property>
            </state>
            <rect id="rect1" width="10%" height="20%" fill="rgb(0, 0, 0)" stroke="black" style="width: 0%;"></rect>
            <rect id="rect2" y="20%" width="10%" height="20%" fill="red" stroke="black" style="width: 100%;"></rect>
          </svg>
        </div>
      </div>
    </div>
  </div>
</body>

</html>